<?php


function _ntm_get_tree($menu_name){
  $cache = &drupal_static('ntm_menu_cache', array());
  if (!isset($cache[$menu_name])) {
    $cache[$menu_name] = menu_build_tree($menu_name);
  }
  return $cache[$menu_name];
}


function _ntm_get_sub_tree_by_mlid($tree, $mlid){
  foreach ($tree as $node) {
    if ($node['link'] && $node['link']['mlid'] == $mlid) return $node;
    if ($node['below']) {
      $node = _ntm_get_sub_tree_by_mlid($node['below'], $mlid);
      if ($node) return $node;
    }
  }
}


function _ntm_menu_items_collect($tree, &$menu_info = array()) {
  foreach ($tree as $node) {
    if ($node['link'] && $node['link']['type'] == MENU_NORMAL_ITEM) {
      $menu_info[$node['link']['mlid']] = array(
        'title' => $node['link']['title'],
        'depth' => $node['link']['depth'],
      );
    }
    if ($node['below']) {
      _ntm_menu_items_collect($node['below'], $menu_info);
    }
  }
  return $menu_info;
}


function _ntm_menu_fix_class(&$tree){
  foreach ($tree as &$node) {
    if (isset($node['#attributes']['class'])) {
      if (isset($node['#below']) && count($node['#below'])) {
        $node['#attributes']['class'][]= 'has_child';
      }
    }
    if (isset($node['#below'])) {
      _ntm_menu_fix_class($node['#below']);
    }
  }
}


function _ntm_tree_render($tree, $style = 'down'){
  $tree = menu_tree_output($tree);
  _ntm_menu_fix_class($tree);
  return '<div class="menu-ntm menu-ntm-'.$style.'">'.drupal_render($tree).'</div>';
}

